// ------------------------------------------------------------
// File:        gov_main.js
//
// Copyright:   (c) 2007 Darren John Dwyer
//              All Rights Reserved.
//
// ------------------------------------------------------------

// ------------------------------------------------------------
// Define Global Variables
// ------------------------------------------------------------

// --- debug
var debug_window_text = null;
var debug_window_frame = null;

// --- timers
var fast_timer = null;
var slow_timer = null;

// ---- border images
var top_left_image = null;
var top_right_image = null;
var top_center_image = null;
var left_edge_image = null;
var right_edge_image = null;
var bottom_left_image = null;
var bottom_right_image = null;
var bottom_center_image = null;

// --- border button images
var main_button_image = null;

// --- button images
var login_button_image = null;
var about_button_image = null;
var information_button_image = null;

// --- other images
var logo_image = null;
var top_bar_image = null;
var middle_bar_image = null;
var bottom_bar_image = null;

// --- text fields
var browser_text = null;
var welcome_text = null;
var to_text = null;
var gov_text = null;

// --- other styles
var right_marquee = null;

// ------------------------------------------------------------
// PaintBorder()
// ------------------------------------------------------------

function PaintBorder()
{
// --- border images
top_left_image 		= new d_Image( 'top_left_image' );
top_right_image 	= new d_Image( 'top_right_image' );
top_center_image 	= new d_Image( 'top_center_image' );
left_edge_image 	= new d_Image( 'left_edge_image' );
right_edge_image	= new d_Image( 'right_edge_image' );
bottom_left_image	= new d_Image( 'bottom_left_image' );
bottom_right_image	= new d_Image( 'bottom_right_image' );
bottom_center_image	= new d_Image( 'bottom_center_image' );

// --- border button images
main_button_image	= new d_Image( 'main_button_image' );
login_button_image	= new d_Image( 'login_button_image' );
information_button_image= new d_Image( 'information_button_image' );
about_button_image	= new d_Image( 'about_button_image' );

// --- draw entire border
top_left_image.FadeIn();
top_right_image.FadeIn();
top_center_image.FadeIn();
left_edge_image.FadeIn();
right_edge_image.FadeIn();
bottom_left_image.FadeIn();
bottom_right_image.FadeIn();
bottom_center_image.FadeIn();

// --- cleanup?
}

// ------------------------------------------------------------
// Pause_Animation()
// ------------------------------------------------------------

function Pause_Animation()
{
if (fast_timer && fast_timer.Active) fast_timer.Pause();
if (slow_timer && slow_timer.Active) slow_timer.Pause();
}

// ------------------------------------------------------------
// Continue_Animation()
// ------------------------------------------------------------

function Continue_Animation()
{
if (fast_timer && fast_timer.Paused) fast_timer.Resume();
if (slow_timer && slow_timer.Paused) slow_timer.Resume();
}

// ------------------------------------------------------------
// Begin_Animation()
// ------------------------------------------------------------

function Begin_Animation()
{
// -----------------
// - CHECK BROWSER -
// -----------------
browser = new d_Browser();
if (!browser || !browser.IE && browser.Version<4)
	{
	if (browser) delete browser;
	alert( 'Please note:\n\nThis site works with Internet Explorer 4+ only.\nIt may not function correctly unless you have a JavaScript 1.2 compatible browser.' );
	return false;
	}

// ------------------
// - CREATE OBJECTS -
// ------------------

// --- debug ---
debug_window_text	= new d_Text( 'debug_window_text' );
debug_window_frame= new d_Image( 'debug_window_frame' );

debug_window_frame.MoveBy( 20, 0 );
debug_window_text.MoveBy( 30, -190 );

// --- images ---
logo_image 		= new d_Image( 'logo_image' );
top_bar_image 	= new d_Image( 'top_bar_image' );
middle_bar_image 	= new d_Image( 'middle_bar_image' );
bottom_bar_image 	= new d_Image( 'bottom_bar_image' );

// --- text ---
welcome_text 	= new d_Text( 'welcome_text' );
to_text 		= new d_Text( 'to_text' );
gov_text 		= new d_Text( 'gov_text' );
browser_text 	= new d_Text( 'browser_text' );

// --- timers ---
fast_timer 		= new d_Timer( 'fast_timer' );
slow_timer 		= new d_Timer( 'slow_timer' );

// --- other ---
right_marquee	= new d_Text( 'right_marquee' );

// --------------
// - SETUP PAGE -
// --------------

// --- logo ---
//logo_image.LoadFromFile( 'images/Frame_150_by_30.gif' );

// --- browser text ---
browser_text.SetHTML( '<FONT FACE="Comic Sans MS" SIZE=-3 COLOR="#DDDDDD">Browser: '+browser.Abbrev+'</FONT>' );

// --- welcome text ---
welcome_text.SetText( 'Please wait... loading...' );
welcome_text.FadeIn();

// --- fast timer ---
fast_timer.Interval = 1;
fast_timer.TimeOut = 100;
fast_timer.OnTick = FastAnimation;
fast_timer.OnStart = FastAnimationOnStart;
fast_timer.OnStop = FastAnimationOnStop;

// --- slow timer ---
slow_timer.Interval = 100;
slow_timer.TimeOut = 21;
slow_timer.OnTick = SlowAnimation;
fast_timer.OnStart = SlowAnimationOnStart;
fast_timer.OnStop = SlowAnimationOnStop;

// -------------------
// - BEGIN ANIMATION -
// -------------------
slow_timer.Start();
//fast_timer.Start();
}


// ------------------------------------------------------------
// End_Animation()
// ------------------------------------------------------------
function End_Animation()
{
slow_timer.Stop();
fast_timer.Stop();

delete slow_timer;
delete fast_timer;

delete browser_text;
delete gov_text;
delete to_text;
delete welcome_text;

delete bottom_bar_image;
delete middle_bar_image;
delete top_bar_image;
delete logo_image;

delete browser;
}

// ------------------------------------------------------------
// stuff for OpenMain()
// ------------------------------------------------------------

var main_button_timer = null;

// ------------------------------------------------------------
// GrowMain()
// ------------------------------------------------------------

function GrowMain()
{
DebugMessage("Growing Main");
var width = debug_window_frame.Width();
if (width<150)
	{
	var pos = 40;
	debug_window_frame.MoveBy( 0, -pos );
	debug_window_frame.GrowBy( pos*2, pos );
	}
}

// ------------------------------------------------------------
// ShrinkMain()
// ------------------------------------------------------------

function ShrinkMain()
{
DebugMessage("Shrinking Main");
var width = main_button_image.Width();
if (width>150)
	{
	var pos = 40;
	main_button_image.MoveBy( 0, pos );
	main_button_image.GrowBy( -pos*2, -pos );
	}
}

// ------------------------------------------------------------
// OpenMain()
// ------------------------------------------------------------

function OpenMain()
{
if (!main_button_image) main_button_image = new d_Image( 'main_button_image' );
if (!main_button_timer) main_button_timer = new d_Timer( 'main_button_timer' );

if (main_button_timer && main_button_image)
	{
	main_button_timer.Interval = 1;
	main_button_timer.TimeOut = 10;
	main_button_timer.Stop();
	main_button_timer.OnTick = GrowMain;
	main_button_timer.Reset();
	main_button_timer.Start();
	}

main_button_image.LoadFromFile( 'images/Frame_140_by_200.gif' );
main_button_image.GrowTo( 140, 200 );
//main_button_image.MoveBy( 0, 200 );
}

// ------------------------------------------------------------
// CloseMain()
// ------------------------------------------------------------

function CloseMain()
{
if (main_button_timer && main_button_image)
	{
	main_button_timer.Interval = 1;
	main_button_timer.TimeOut = 20;
	main_button_timer.Stop();
	main_button_timer.OnTick = ShrinkMain;
	main_button_timer.Reset();
	main_button_timer.Start();
	}

main_button_image.LoadFromFile( 'images/Frame_140_by_60.gif' );
main_button_image.GrowTo( 140, 60 );
//main_button_image.MoveBy( 0, -200 );
}

// ------------------------------------------------------------
var debug_window_timer = null;
var debug_window_mode = 'closed';

function OpenDebug()
{
if (!debug_window_timer) debug_window_timer = new d_Timer( 'debug_window_timer' );
if (!debug_window_frame) debug_window_frame = new d_Image( 'debug_window_frame' );
if (!debug_window_text) debug_window_text = new d_Text( 'debug_window_text' );

if (debug_window_timer && debug_window_frame && debug_window_text)
	{
	DebugMessage("DebugWindow: Open");
	if (debug_window_mode=='closed') 
		{
		DebugMessage("Debug: opening closed");

		debug_window_timer.Stop();
		debug_window_timer.Interval = 1;
		debug_window_timer.Increment = 1;
		debug_window_timer.TickCount = 1;
		debug_window_timer.TimeOut = 11;
		debug_window_timer.OnTick = GrowDebug;
		debug_window_timer.OnStart = StartGrowDebug;
		debug_window_timer.OnStop = StopGrowDebug;
		debug_window_timer.Start();
		}
	else if (debug_window_mode=='closing')
		{
		DebugMessage("Debug: re-opening");

		debug_window_timer.Stop();
		debug_window_timer.Interval = 1;
		debug_window_timer.Increment = 1;
		debug_window_timer.TimeOut = 11;
		debug_window_timer.OnTick = GrowDebug;
		debug_window_timer.OnStart = StartGrowDebug;
		debug_window_timer.OnStop = StopGrowDebug;
		debug_window_timer.Start();
		}
	else if (debug_window_mode=='open')
		{
		DebugMessage("Debug: Already Open" );
		}
	else if (debug_window_mode=='opening')
		{
		DebugMessage("Debug: Already Opening" );
		}
	}
}

function CloseDebug()
{
if (!debug_window_timer) debug_window_timer = new d_Timer( 'debug_window_timer' );
if (!debug_window_frame) debug_window_frame = new d_Image( 'debug_window_frame' );
if (!debug_window_text) debug_window_text = new d_Text( 'debug_window_text' );

if (debug_window_timer && debug_window_frame && debug_window_text)
	{
	DebugMessage("DebugWindow: Close");
	if (debug_window_mode=='open')
		{
		DebugMessage("Debug: closing open" );

		debug_window_timer.Stop();
		debug_window_timer.Interval = 1;
		debug_window_timer.Increment = -1;
		debug_window_timer.TickCount = 10;
		debug_window_timer.TimeOut = 0;
		debug_window_timer.OnTick = ShrinkDebug;
		debug_window_timer.OnStart = StartShrinkDebug;
		debug_window_timer.OnStop = StopShrinkDebug;
		debug_window_timer.Start();
		}
	else if (debug_window_mode=='opening')
		{
		DebugMessage("Debug: re-closing" );

		debug_window_timer.Stop();
		debug_window_timer.Interval = 1;
		debug_window_timer.Increment = -1;
		debug_window_timer.TimeOut = 0;
		debug_window_timer.OnTick = ShrinkDebug;
		debug_window_timer.OnStart = StartShrinkDebug;
		debug_window_timer.OnStop = StopShrinkDebug;
		debug_window_timer.Start();
		}
	else if (debug_window_mode=='closed') 
		{
		DebugMessage("Debug: Already Closed" );
		}
	else if (debug_window_mode=='closing')
		{
		DebugMessage("Debug: Already Closing" );
		}
	}
}

function GrowDebug()
{
if (debug_window_timer && debug_window_frame && debug_window_text)
	{
	var width = debug_window_timer.TickCount*14;
	debug_window_frame.GrowTo( width, 200 );
	if (width>20) width -= 20; else width = 0;
	debug_window_text.GrowTo( width, 180 );
	}
}

function ShrinkDebug()
{
if (debug_window_timer && debug_window_frame && debug_window_text)
	{
	var width = debug_window_timer.TickCount*14;
	debug_window_frame.GrowTo( width, 200 );
	if (width>20) width -= 20; else width = 0;
	debug_window_text.GrowTo( width, 180 );
	}
}

function StartGrowDebug()
{
debug_window_mode = 'opening';
if (start_sound)
	{
	start_sound.src = '';
	start_sound.src = 'sounds/open.wav';
	}
}

function StopGrowDebug()
{
debug_window_mode = 'open';
}

function StartShrinkDebug()
{
debug_window_mode = 'closing';
if (start_sound)
	{
	start_sound.src = '';
	start_sound.src = 'sounds/close.wav';
	}
}

function StopShrinkDebug()
{
debug_window_mode = 'closed';
}


// ------------------------------------------------------------
// OpenFrame()
// ------------------------------------------------------------

function OpenFrame( image_name, file_name, width, height )
{
DebugMessage('OpenFrame('+image_name+', '+file_name+', '+width+', '+height+')' );
var temp_image = new d_Image( image_name );

if (temp_image)
	{
	up_sound.src = '';
	up_sound.src = 'sounds/pop.wav';

	temp_image.LoadFromFile( file_name );
	temp_image.GrowTo( width, height );
	delete temp_image;
	}
}

// ------------------------------------------------------------
// CloseFrame()
// ------------------------------------------------------------

function CloseFrame( image_name, file_name, width, height )
{
DebugMessage('CloseFrame('+image_name+', '+file_name+', '+width+', '+height+')' );
var temp_image = new d_Image( image_name );
if (temp_image)
	{
	temp_image.LoadFromFile( file_name );
	temp_image.GrowTo( width, height );
	delete temp_image;
	}
}

// ------------------------------------------------------------
// FastAnimationOnStart()
// ------------------------------------------------------------

function FastAnimationOnStart()
{
DebugMessage( '12> Begin FastAnim' );
}

// ------------------------------------------------------------
// FastAnimationOnStop()
// ------------------------------------------------------------

function FastAnimationOnStop()
{
DebugMessage( '13> End FastAnim' );
}

// ------------------------------------------------------------
// FastAnimation()
// ------------------------------------------------------------

function FastAnimation()
{
DebugMessage( 'FAST> Frame:' +fast_timer.TickCount );

//logo_image.MoveTo( fast_timer.TickCount, fast_timer.TickCount );
//welcome_text.MoveTo( 4*fast_timer.TickCount, 4*fast_timer.TickCount );
}

// ------------------------------------------------------------
// SlowAnimationOnStart()
// ------------------------------------------------------------

function SlowAnimationOnStart()
{
DebugMessage( '0> Begin SlowAnim' );
}

// ------------------------------------------------------------
// SlowAnimationOnStop()
// ------------------------------------------------------------

function SlowAnimationOnStop()
{
DebugMessage( 'SLOW> End SlowAnim' );
}

// ------------------------------------------------------------
// SlowAnimation()
// ------------------------------------------------------------

function SlowAnimation()
{
//status = "SlowAnimation(), TickCount=="+slow_timer.TickCount;
//DebugMessage( status );

switch (slow_timer.TickCount)
	{
	case 0:

		DebugMessage( '0> Paint Border' );
		PaintBorder();
		break;

	case 1:
		DebugMessage( '1> Show Debug Frame' );
		Debug_Header = 'Trace Info';
		Debug_Max_Lines = 7;
//		debug_window_frame.FadeIn();
		break;

	case 2:

		DebugMessage( '2> Show Debug Text' );
//		debug_window_text.FadeIn();
		break;

	case 3:
		DebugMessage( '3> Begin Animation' );
		break;

	case 4:
		DebugMessage( '4> Show Top Bar' );
		top_bar_image.FadeIn();
		break;

	case 5:

		DebugMessage( '5> Show Middle Bar' );
		middle_bar_image.FadeIn();
		break;

	case 6:

		DebugMessage( '6> Show Bottom Bar' );
		bottom_bar_image.FadeIn();
		break;

	case 7:

		DebugMessage( '7> Show Welcome' );
		welcome_text.SetHTML( '<FONT FACE="Comic Sans MS" SIZE=+0 COLOR="GREEN">WELCOME</FONT>' );
		welcome_text.FadeIn();
		break;

	case 8:

		DebugMessage( '8> Show To' );
		to_text.FadeIn();
		break;

	case 9:

		DebugMessage( '9> Show GOV' );
		gov_text.FadeIn();
		break;

	case 10:

		DebugMessage( '10> Show Logo' );
		logo_image.FadeIn();
		break;

	case 11:

		DebugMessage( '11> Show Info Button' );
		information_button_image.FadeIn();
		break;

	case 12:

		DebugMessage( '12> Show Login Button' );
		login_button_image.FadeIn();
		break;

	case 13:

		DebugMessage( '13> Show About Button' );
		about_button_image.FadeIn();
		break;

	case 19:

		DebugMessage( '19> Hide Logo Image' );
		fast_timer.Start();
		main_button_image.LoadFromFile( 'images/Frame_140_by_200.gif' );
		main_button_image.FadeIn();
		break;

	case 20:

		DebugMessage( '20> Show Marquee' );
		right_marquee.Show();
		logo_image.FadeOut();
		break;

	case 21:

		DebugMessage( '21> Do Nothing' );
		break;

	}
return true;
}

// ------------------------------------------------------------
// PageMouseOver()
// ------------------------------------------------------------

function PageMouseOver()
{
status = 	'event type=='+event.type+
		', target=='+event.target+
		', layerX=='+event.layerX+
		', layerY=='+event.layerY+
		', pageX=='+event.pageX+
		', pageY=='+event.pageY+
		', screenX=='+event.screenX+
		', screenY=='+event.screenY;
//DebugMessage(status);
}

// ------------------------------------------------------------
// PageMouseMove()
// ------------------------------------------------------------

function PageMouseMove()
{
status = 	'event type=='+event.type+
		', target=='+event.target+
		', layerX=='+event.layerX+
		', layerY=='+event.layerY+
		', pageX=='+event.pageX+
		', pageY=='+event.pageY+
		', screenX=='+event.screenX+
		', screenY=='+event.screenY;

//DebugMessage(status);

if (IE)
	{
	if (document.all["mouse_tracker_text"])
		{
//		document.all["mouse_tracker_text"].style.top = event.screenY;
//		document.all["mouse_tracker_text"].style.left = event.screenX;
		}
	}
else 
	{
	if (document["mouse_tracker_text"])
		{
		document["mouse_tracker_text"].pixelTop = event.screenY;
		document["mouse_tracker_text"].pixelLeft = event.screenX;
		}
	}

if (event.screenX<10) 
	{
	document.all["up_sound"].src = 'sounds/goodbye.wav';
	document.all["up_sound"].volume = 0;
	}
else if (event.screenX>1000)
	{
	document.all["up_sound"].src = 'sounds/error.wav';
	document.all["up_sound"].volume = 0;
	}
}


// ------------------------------------------------------------
