// ------------------------------------------------------------
// File:        gov_application.js
//
// Copyright:   (c) 2002 Darren John Dwyer, Sydney, Australia,
//              All Rights Reserved.
//
// ------------------------------------------------------------
// Website Application
//
// this is the basis of a gov_lib "webpage application".
//
// ------------------------------------------------------------
// Example:
//
//    <!-- insert into html file -->
//    <BODY     OnLoad="Begin();"
//        OnUnLoad="End();">
//    <SCRIPT    Language="Javascript">
//    <!-- // this line is required to hide script from older browsers
//
//    var main_application;
//    function Begin()
//        {
//        main_application = new d_Application( 'main_application' );
//        if (main_application && main_application.CreatedOk)
//            {
//            main_application.OnStart = main_setup;
//            main_application.OnFinish = main_cleanup;
//            main_application.OnPaint = main_paint;
//            main_application.Run();
//            }
//        }
//    function End()
//        {
//        if (my_application)
//            {
//            my_application.Destroy();
//            delete my_application;
//            my_application = null;
//        }
//    ...
//
//    // custom functions here
//    function main_setup()
//        {
//        // create objects here
//        }
//
//    function main_cleanup()
//        {
//        // delete objects here
//        }
//
//    function main_paint()
//        {
//        // do custom animation here
//        }
//
//    // this line is required to hide script from older browsers -->
//    </SCRIPT>
// ------------------------------------------------------------

// ------------------------------------------------------------
// Define Global Variables
// ------------------------------------------------------------

var     d_Application_Counter = 0;
var    d_Application_Debug = true;

// ------------------------------------------------------------
// Object Definition
// ------------------------------------------------------------

function d_Application( name )
{
    // ----------------------------------------------------
    // Properties
    // ----------------------------------------------------

    this.Name        = name;
    this.Type        = 'd_Application';
    this.Id            = d_Application_Counter++;

    // ----------------------------------------------------
    // Methods
    // ----------------------------------------------------

    this.Run        = d_Application_Run;
    this.Restart        = d_Application_Restart;

    // ----------------------------------------------------
    // Events
    // ----------------------------------------------------

    this.OnStart        = d_Application_OnStart;
    this.OnFinish        = d_Application_OnFinish;
    this.OnTick        = d_Application_OnTick;
    this.OnRestart        = d_Application_OnRestart;

}

// ------------------------------------------------------------
// End of Object Definition
// ------------------------------------------------------------


// ------------------------------------------------------------
// Method Code
// ------------------------------------------------------------

// ------------------------------------------------------------

function d_Application_Run()
{
}

// ------------------------------------------------------------

function d_Application_Restart()
{
}

// ------------------------------------------------------------

// ------------------------------------------------------------
// Default Event Handling Code
// ------------------------------------------------------------

// ------------------------------------------------------------

function d_Application_OnStart()
{
if (d_Application_Debug) status = "Note: "+this.Name+"::OnStart()";
}

// ------------------------------------------------------------

function d_Application_OnFinish()
{
if (d_Application_Debug) status = "Note: "+this.Name+"::OnFinish()";
}

// ------------------------------------------------------------

function d_Application_OnTick()
{
if (d_Application_Debug) status = "Note: "+this.Name+"::OnTick()";
}

// ------------------------------------------------------------

function d_Application_OnRestart()
{
if (d_Application_Debug) status = "Note: "+this.Name+"::OnRestart()";
}

// ------------------------------------------------------------
