// ------------------------------------------------------------
// File:        gov_browser.js
//
// Copyright:   (c) 2002 Darren John Dwyer, Sydney, Australia,
//              All Rights Reserved.
//
// ------------------------------------------------------------
// Browser compatibility
//
// This file checks the browsers' compatibility with gov_files
//
// ------------------------------------------------------------
// Example:
//
//    <SCRIPT SRC="javascript/gov_browser.js">
//    ...
//    function MyFunction()
//        {
//        if (IE) DoMicrosoftStuff();
//        else DoNetscapeStuff();    
//        }
//    ...
//    function MyFunction2()
//        {
//        var browser = new d_Browser();
//        if (browser.NE5)
//            alert("Netscape 5+");
//        if (browser.Name == "Netscape" &&
//            browser.Version > 5) 
//            alert("Netscape 5+");
//        }
//
// Note: When writing code for browsers, if the code works in 
// Netscape, it should work for most browsers, except for IE
// usually. When writing for IE, assume Netscape (etc) will 
// NOT support the same kind of functionality.
//            
// ------------------------------------------------------------

var IE = (navigator.appName=='Microsoft Internet Explorer');
var NS = (navigator.appName=='Netscape');

// ------------------------------------------------------------

function d_Browser()
{
this.Name        = d_Browser_Name();
this.Abbrev        = d_Browser_Abbrev();
this.Version         = d_Browser_Version();

this.IE            = d_Browser_IE();
this.IE3        = d_Browser_IE3();
this.IE4        = d_Browser_IE4();
this.IE5        = d_Browser_IE5();
this.IE6        = d_Browser_IE6();

this.NS            = d_Browser_NS();
this.NS3        = d_Browser_NS3();
this.NS4        = d_Browser_NS4();
this.NS5        = d_Browser_NS5();
this.NS6        = d_Browser_NS6();
}

// ------------------------------------------------------------
function d_Browser_Name()
{
return navigator.appName;
}
// ------------------------------------------------------------
function d_Browser_Abbrev()
{
if (navigator.appName=='Microsoft Internet Explorer') return 'IE'+parseFloat(navigator.appVersion);
if (navigator.appName=='Netscape') return 'NS'+parseFloat(navigator.appVersion);
return navigator.appName+parseFloat(navigator.appVersion);
}
// ------------------------------------------------------------
function d_Browser_Version()
{
return parseFloat(navigator.appVersion);
}
// ------------------------------------------------------------
function d_Browser_IE()
{
return (navigator.appName == 'Microsoft Internet Explorer');
}
// ------------------------------------------------------------
function d_Browser_IE3()
{
return ((navigator.appName == 'Microsoft Internet Explorer') && (parseFloat(navigator.appVersion) >= 3.0));
}
// ------------------------------------------------------------
function d_Browser_IE4()
{
return ((navigator.appName == 'Microsoft Internet Explorer') && (parseFloat(navigator.appVersion) >= 4.0));
}
// ------------------------------------------------------------
function d_Browser_IE5()
{
return ((navigator.appName == 'Microsoft Internet Explorer') && (parseFloat(navigator.appVersion) >= 5.0));
}
// ------------------------------------------------------------
function d_Browser_IE6()
{
return ((navigator.appName == 'Microsoft Internet Explorer') && (parseFloat(navigator.appVersion) >= 6.0));
}

// ------------------------------------------------------------
function d_Browser_NS()
{
return (navigator.appName == 'Netscape');
}
// ------------------------------------------------------------
function d_Browser_NS3()
{
return ((navigator.appName == 'Netscape') && (parseFloat(navigator.appVersion) >= 3.0));
}
// ------------------------------------------------------------
function d_Browser_NS4()
{
return ((navigator.appName == 'Netscape') && (parseFloat(navigator.appVersion) >= 4.0));
}
// ------------------------------------------------------------
function d_Browser_NS5()
{
return ((navigator.appName == 'Netscape') && (parseFloat(navigator.appVersion) >= 5.0));
}
// ------------------------------------------------------------
function d_Browser_NS6()
{
return ((navigator.appName == 'Netscape') && (parseFloat(navigator.appVersion) >= 6.0));
}
// ------------------------------------------------------------
