// ------------------------------------------------------------
// File:        djd.js
// Copyright:   (c) 2000 Darren John Dwyer, Sydney, Australia,
//              All Rights Reserved.


// ------------------------------------------------------------
// Browser compatibility
//
// The following variables can be used to check the browser's 
// compatibility with JavaScript 1.2 any time after calling the
// CheckBrowserCompatibility() method -->
// ------------------------------------------------------------

var Browser_Is_Compatible = false;

// The following method checks the browser's compatibility with JavaScript 1.2
// and sets the Browser_Is_Compatible variable to true if compatible, false otherwise

function CheckBrowserCompatibility()
{
var name = navigator.appName;
var version = parseFloat(navigator.appVersion);

if ((name == 'Netscape' && version >= 3) || 
    (name == 'Microsoft Internet Explorer' && version >= 4))

    Browser_Is_Compatible = true;
else

    Browser_Is_Compatible = false;

return true;
}


// ------------------------------------------------------------
// Menu
// ------------------------------------------------------------

var Menu_Images_Hi = new Array();
var Menu_Images_Lo = new Array();
var Menu_Images_Path = ".";
var Menu_Default_Button = "";

function Menu_SetImagesPath( path )
{
Menu_Images_Path = path;
}

function Menu_SetDefaultButton( name )
{
Menu_Default_Button = name;
document.images[name].src = Menu_Images_Hi[name].src;    
}

function Menu_LoadImage( image_name )
{
Menu_Images_Hi[image_name] = new Image();
Menu_Images_Lo[image_name] = new Image();

Menu_Images_Hi[image_name].src = Menu_Images_Path+"/Images/"+image_name+"_Hi.gif";
Menu_Images_Lo[image_name].src = Menu_Images_Path+"/Images/"+image_name+"_Lo.gif";

return true;
}

function Menu_HighlightButton( button_name )
{
if (Browser_Is_Compatible)
  {
  // lowlight the existing button
  if (Menu_Default_Button != "")
    if (Menu_Default_Button != button_name)
      document.images[Menu_Default_Button].src = Menu_Images_Lo[Menu_Default_Button].src;

  // highlight desired button
  document.images[button_name].src = Menu_Images_Hi[button_name].src;
  }
return true;
}

function Menu_LowlightButton( button_name )
{
if (Browser_Is_Compatible)
  document.images[button_name].src = Menu_Images_Lo[button_name].src;

return true;
}

// ------------------------------------------------------------
// Cookies
// ------------------------------------------------------------

// Heinle's function for retrieving a cookie.
function getCookie(name){
  var cname = name + "=";               
  var dc = document.cookie;             
  if (dc.length > 0) {              
    begin = dc.indexOf(cname);       
    if (begin != -1) {           
      begin += cname.length;       
      end = dc.indexOf(";", begin);
      if (end == -1) end = dc.length;
        return unescape(dc.substring(begin, end));
    } 
  }
  return null;
}

// An adaptation of Dorcht's function for setting a cookie.
function setCookie(name, value, expires, path, domain, secure) {
  document.cookie = name + "=" + escape(value) + 
  ((expires == null) ? "" : "; expires=" + expires.toGMTString()) +
  ((path == null) ? "" : "; path=" + path) +
  ((domain == null) ? "" : "; domain=" + domain) +
  ((secure == null) ? "" : "; secure");
}

// An adaptation of Dorcht's function for deleting a cookie.
function delCookie (name,path,domain) {
  if (getCookie(name)) {
    document.cookie = name + "=" +
    ((path == null) ? "" : "; path=" + path) +
    ((domain == null) ? "" : "; domain=" + domain) +
    "; expires=Thu, 01-Jan-70 00:00:01 GMT";
  }
}

function popwin() {
	if (getCookie("DelphiProPopup") != "True")
		{
		setCookie('DelphiProPopup', 'True');
		window.open('popup.htm', 'Links', 'resizable,width=230,height=330')
		}
}


function TObject( Name )
{
// Declare any Properties
this.Name = Name;
this.Type = "TObject";

// Declare any Methods
this.GetName = TObject_GetName;
}

function TObject_GetName()
{
var Name = this.Name;
return Name;
}

